Adding short component

This commit is contained in:
Alex Epstein 2017-06-30 09:47:57 -04:00
parent 91521c5ebd
commit ccb751ec01
5 changed files with 210 additions and 0 deletions

View File

@ -60,6 +60,15 @@ if [[ $# == 0 ]]; then
cd .. || exit 1
fi
unset answer
echo -n "Do you wish to install short [Y/n]: "
read -r answer
if [[ "$answer" == "Y" || "$answer" == "y" ]] ;then
cd short || exit 1
./install.sh
cd .. || exit 1
fi
fi
if [[ $1 == "currency" ]];then
@ -86,6 +95,10 @@ elif [[ $1 == "taste" ]]; then
cd taste || exit 1
./install.sh || exit 1
cd .. || exit 1
elif [[ $1 == "short" ]]; then
cd short || exit 1
./install.sh || exit 1
cd .. || exit 1
elif [[ $1 == "all" ]];then
cd currency || exit 1
./install.sh || exit 1
@ -105,6 +118,9 @@ elif [[ $1 == "all" ]];then
cd taste || exit 1
./install.sh || exit 1
cd .. || exit 1
cd short || exit 1
./install.sh || exit 1
cd .. || exit 1
elif [[ $1 == "update" ]]; then
echo "Updating scripts..."
if [[ -f /usr/local/bin/currency ]];then
@ -137,6 +153,11 @@ elif [[ $1 == "update" ]]; then
./install.sh || exit 1
cd .. || exit 1
fi
if [[ -f /usr/local/bin/short ]];then
cd short || exit 1
./install.sh || exit 1
cd .. || exit 1
fi
fi
echo "Bash Snippets version $currentVersion"

6
short/install.sh Executable file
View File

@ -0,0 +1,6 @@
#!/bin/bash
# Author: Alexander Epstein https://github.com/alexanderepstein
echo -n "Installing short: "
chmod a+x short
cp short /usr/local/bin > /dev/null 2>&1 || { echo "Failure"; echo "Error copying file, try running install script as sudo"; exit 1; }
echo "Success"

168
short/short Executable file
View File

@ -0,0 +1,168 @@
#!/bin/bash
# Author: Alexander Epstein https://github.com/alexanderepstein
currentVersion="1.4.0"
configuredClient=""
## This function determines which http get tool the system has installed and returns an error if there isnt one
getConfiguredClient()
{
if command -v curl &>/dev/null ; then
configuredClient="curl"
elif command -v wget &>/dev/null ; then
configuredClient="wget"
elif command -v fetch &>/dev/null ; then
configuredClient="fetch"
else
echo "Error: This tool reqires either curl, wget, or fetch to be installed."
return 1
fi
}
## Allows to call the users configured client without if statements everywhere
httpGet()
{
case "$configuredClient" in
curl) curl -A curl -s "$@";;
wget) wget -qO- "$@";;
fetch) fetch -o "...";;
esac
}
checkInternet()
{
echo -e "GET http://google.com HTTP/1.0\n\n" | nc google.com 80 > /dev/null 2>&1 # query google with a get request
if [ $? -eq 0 ]; then #check if the output is 0, if so no errors have occured and we have connected to google successfully
return 0
else
echo "Error: no active internet connection" >&2 #sent to stderr
return 1
fi
}
update()
{
# Author: Alexander Epstein https://github.com/alexanderepstein
# Update utility version 1.2.0
# To test the tool enter in the defualt values that are in the examples for each variable
repositoryName="Bash-Snippets" #Name of repostiory to be updated ex. Sandman-Lite
githubUserName="alexanderepstein" #username that hosts the repostiory ex. alexanderepstein
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option
if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]];then
echo "Error: update utility has not been configured correctly." >&2
exit 1
elif [[ $latestVersion == "" ]];then
echo "Error: no active internet connection" >&2
exit 1
else
if [[ "$latestVersion" != "$currentVersion" ]]; then
echo "Version $latestVersion available"
echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer
if [[ "$answer" == "Y" || "$answer" == "y" ]] ;then
cd ~ || { echo 'Update Failed' ; exit 1 ; }
if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi
git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; }
cd $repositoryName || { echo 'Update Failed' ; exit 1 ;}
git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh #this might be necessary in your case but wasnt in mine.
./$nameOfInstallFile "update" || exit 1
cd ..
rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; }
else
exit 1
fi
else
echo "$repositoryName is already the latest version"
fi
fi
}
usage()
{
echo "Short tool"
echo "Usage: short [shortURL] or short [flag]"
echo " -u Update Bash-Snippet Tools"
echo " -h Show the help"
echo " -v Get the tool version"
}
expandURL()
{
testURL=$( echo $1 | cut -c1-8 )
if [[ $testURL != "https://" ]];then
testURL=$( echo $1 | cut -c1-7 )
if [[ $testURL != "http://" ]];then
url="http://$1"
else
url=$1
fi
else
url=$1
fi
response=$(httpGet http://x.datasig.io/short?url=$url)
errorCheck=$(echo $response | python -c "import sys, json; print json.load(sys.stdin)['/short']['message']" 2> /dev/null )
if [[ $errorCheck == "Error in /short" ]];then
echo "Error: 404 could not find the website"
return 1
fi
expandedURL=$(echo $response | python -c "import sys, json; print json.load(sys.stdin)['/short']['destination']" 2> /dev/null )
}
printResults()
{
echo "====================================================================="
echo "Short URL: $url"
echo "Expanded URL: $expandedURL"
echo "====================================================================="
}
getConfiguredClient || exit 1
checkInternet || exit 1
while getopts "uvh" opt; do
case $opt in
\?)
echo "Invalid option: -$OPTARG" >&2
exit 1
;;
h)
usage
exit 0
;;
v)
echo "Version $currentVersion"
exit 0
;;
u)
update
exit 0
;;
:)
echo "Option -$OPTARG requires an argument." >&2
exit 1
;;
esac
done
if [[ $# == 0 ]]; then
usage
exit 0
elif [[ $# == "1" ]]; then
if [[ $1 == "update" ]];then
update
elif [[ $1 == "help" ]]; then
usage
else
expandURL $1 || exit 1
printResults
fi
else
echo "Error: short only accepts one argument"
exit 1
fi

5
short/uninstall.sh Executable file
View File

@ -0,0 +1,5 @@
#!/bin/bash
# Author: Alexander Epstein https://github.com/alexanderepstein
echo -n "Removing short: "
rm -f /usr/local/bin/short > /dev/null 2>&1 || { echo "Failed" ; echo "Error removing file, try running uninstall script as sudo"; exit 1; }
echo "Success"

View File

@ -67,3 +67,13 @@ if [[ -f /usr/local/bin/taste ]];then
cd .. || exit 1
fi
fi
if [[ -f /usr/local/bin/short ]];then
echo -n "Do you wish to uninstall movies [Y/n]: "
read -r answer
if [[ "$answer" == "Y" || "$answer" == "y" ]] ;then
cd short || exit 1
./uninstall.sh
cd .. || exit 1
fi
fi